﻿/*
 * 作成日： 2004/08/05
 *
 * TODO この生成されたファイルのテンプレートを変更するには次を参照。
 * ウィンドウ ＞ 設定 ＞ Java ＞ コード・スタイル ＞ コード・テンプレート
 */
package dictionary;

import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.awt.event.*;
import java.beans.*;
import java.io.*;

/**
 * @author Administrator Sho Hashimoto
 *
 * TODO この生成された型コメントのテンプレートを変更するには次を参照。
 * ウィンドウ ＞ 設定 ＞ Java ＞ コード・スタイル ＞ コード・テンプレート
 */
public class Dictionary extends JFrame implements ActionListener,
        ListSelectionListener {

    private String dicFile = "dic.xml"; // 辞書ファイル名

    private WordSet wordSet; // 単語集

    private JPanel panel; // メインパネル

    private JTextField jpWordText, enWordText; // 単語(日)、単語(英)

    private JTextArea notesText; // 内容
    
    private JLabel statusBar; // ステータスバー

    private JButton submitButton, delButton, clearButton; // 登録ボタン, 削除ボタン, クリアボタン

    private JList wordList;

    public static void main(String[] args) {
        Dictionary app = new Dictionary();
    }

    /*
     * コンストラクタ
     */
    public Dictionary() {
        this.fload(); // wordsを初期化
        this.gui_init();
    }

    /*
     * GUIセットアップ
     */
    protected void gui_init(){
        this.setTitle("単語帳");
        this.setBounds(10, 10, 570, 450);
        //this.setResizable(false);
        this.getContentPane().setLayout(new BorderLayout());
        
        /* JMenuBar */
        JMenuBar menuBar = new JMenuBar();
        JMenu menuLF = new JMenu("Look & Feel");
        ButtonGroup groupLF = new ButtonGroup();
        JRadioButtonMenuItem rm1, rm2, rm3;
        groupLF.add(rm1 = new JRadioButtonMenuItem("Metal", true));
        groupLF.add(rm2 = new JRadioButtonMenuItem("Motif"));
        groupLF.add(rm3 = new JRadioButtonMenuItem("Windows"));
        menuLF.add(rm1);
        menuLF.add(rm2);
        menuLF.add(rm3);
        menuBar.add(menuLF);
        rm1.setActionCommand("LFMetal");
        rm1.addActionListener(this);
        rm2.setActionCommand("LFMotif");
        rm2.addActionListener(this);
        rm3.setActionCommand("LFWindows");
        rm3.addActionListener(this);
        
        this.setJMenuBar(menuBar);
        
        /* ContentPane */
        this.panel = new JPanel();

        Box b1, b2, b3;
        b1 = Box.createVerticalBox();
        b2 = Box.createVerticalBox();
        b3 = Box.createVerticalBox();
        JPanel p1, p2, p3, p4, p5, p6, p7, p8;
        b1.add(p1 = new JPanel());
        b1.add(p2 = new JPanel());
        b1.add(p3 = new JPanel());
        b1.add(p4 = new JPanel());
        b2.add(p5 = new JPanel());
        b2.add(p6 = new JPanel());
        b2.add(p7 = new JPanel());
        b3.add(p8 = new JPanel());

        this.panel.add(b1);
        this.panel.add(b2);

        /* 左側のパーツ */
        p1.add(new JLabel("単語(日)"));
        p1.add(this.jpWordText = new JTextField(20));
        p1.setLayout(new FlowLayout(FlowLayout.LEFT));
        p2.add(new JLabel("単語(英)"));
        p2.add(this.enWordText = new JTextField(20));
        p2.setLayout(new FlowLayout(FlowLayout.LEFT));
        p8.add(new JLabel("説明"));
        p8.setLayout(new FlowLayout(FlowLayout.LEFT));
        b3.add(this.notesText = new JTextArea(13, 30));
        this.notesText.setLineWrap(true);
        p3.add(b3);

        p4.add(this.clearButton = new JButton("新規単語"));
        this.clearButton.setActionCommand("Clear");
        this.clearButton.addActionListener(this);

        p4.add(this.submitButton = new JButton("登録"));
        this.submitButton.setActionCommand("AddWord");
        this.submitButton.addActionListener(this);

        /* 右側のパーツ */
        p5.add(new JLabel("単語リスト"));
        p5.setLayout(new FlowLayout(FlowLayout.LEFT));
        JScrollPane wordListScr = new JScrollPane();
        p6.add(wordListScr);
        p7.add(this.delButton = new JButton("削除"));
        this.delButton.setActionCommand("DelWord");
        this.delButton.addActionListener(this);

        wordListScr.getViewport().setView(this.wordList = new JList()); // スクロールバーに入れる
        this.wordList.addListSelectionListener(this); // リスト選択リスナー登録
        this.wordList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION); // 一つしか選択出来ない
        wordListScr.setPreferredSize(new Dimension(200, 270));
        this.syncWordSet(); // 同期

        this.getContentPane().add(this.panel, BorderLayout.CENTER);

        this.getContentPane().add(this.statusBar = new JLabel(" "), BorderLayout.SOUTH);
        this.statusBar.setBorder(new BevelBorder(BevelBorder.LOWERED));
        
        this.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e){
                System.exit(0);
            }
        });

        this.setVisible(true);
    }

    /*
     * GUIのJTextFieldの全クリア
     */
    private void gui_text_clear() {
        this.jpWordText.setText(""); // JTextField初期化
        this.enWordText.setText("");
        this.notesText.setText("");
    }

    /*
     * ListSelectionEvent
     * @see javax.swing.event.ListSelectionListener#valueChanged(javax.swing.event.ListSelectionEvent)
     */
    public void valueChanged(ListSelectionEvent e) {
        String sel = (String) this.wordList.getSelectedValue(); // 選択した文字
        Word w = this.wordSet.get(sel); // 選択した文字を持つWordを取得
        this.jpWordText.setText(w.getJpName()); // TextFieldに書く
        this.enWordText.setText(w.getEnName());
        this.notesText.setText(w.getNotes());
        
    }

    /*
     * ActionEvent
     * 
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent ae) {
        String action = ae.getActionCommand(); // アクションコマンド名
        //登録ボタンが押された時の処理
        if (action.equals("AddWord")) {
            if (!(jpWordText.getText().equals("") && enWordText.getText().equals(""))) {
                Word word =new Word(this.jpWordText.getText(), this.enWordText.getText(), this.notesText.getText());
                if(this.wordSet.remove(word.toString())){ // 同じ名前の単語があれば削除
                    message("編集:" + word.toString());
                }
                else this.message("追加:" + word.toString());
                this.wordSet.add(word); // 単語追加
                this.syncWordSet(); // 同期
                this.fsave(); // ファイル保存
                this.gui_text_clear(); // TextField全クリア
            }
        }

        //削除ボタンが押された時の処理
        if (action.equals("DelWord")) {
            String name = (String)this.wordList.getSelectedValue(); // 選択された単語名
            this.wordSet.remove(name); // 削除
            this.syncWordSet(); // 同期
            this.fsave(); // ファイル保存
            this.gui_text_clear(); // TextField全クリア
            this.message("削除:" + name);
        }

        //クリアボタンが押された時の処理
        if (action.equals("Clear")) {
            this.gui_text_clear(); // TextField全クリア
        }
        
        // Look & Feel変更 Metal
        if(action.equals("LFMetal")){
            try {
                UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
                SwingUtilities.updateComponentTreeUI(this);
            } catch (Exception e) {
                this.message(e.toString());
            }
        }
        
        // Look & Feel変更 Motif
        if(action.equals("LFMotif")){
            try {
                UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
                SwingUtilities.updateComponentTreeUI(this);
            } catch (Exception e) {
                this.message(e.toString());
            }
        }
        
        // Look & Feel変更 Windows
        if(action.equals("LFWindows")){
            try {
                UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
                SwingUtilities.updateComponentTreeUI(this);
            } catch (Exception e) {
                this.message(e.toString());
            }
        }
    }

    /*
     * GUIの単語リストと、wordSetを同期させる
     */
    private void syncWordSet() {
        this.wordList.setListData(this.wordSet.toArray()); // wordSetから生成した配列をセット
    }

    /*
     * XMLファイルにwordSetの状態を保存
     */
    private void fsave() {

        try {
            XMLEncoder xenc = new XMLEncoder(new BufferedOutputStream(
                    new FileOutputStream(this.dicFile)));
            xenc.writeObject(this.wordSet); // wordSetの状態をXMLとして保存
            xenc.close(); // 閉じる
        } catch (Exception e) { // 例外処理
            System.out.println("Exception : " + e);
        } finally {
            System.out.println("辞書ファイル(XML)出力完了");
        }
    }

    /*
     * XMLファイルを読み、wordSetの状態を復元
     */
    private void fload() {
        try {
            XMLDecoder xdec = new XMLDecoder(new BufferedInputStream(
                    new FileInputStream(this.dicFile))); // private dicFileで指定したXMLファイルを開く
            this.wordSet = (WordSet) xdec.readObject(); // wordSetの状態をXMLファイルから復元
            xdec.close(); // 閉じる
        } catch (Exception e) { // 例外処理
            System.out.println("Exception : " + e);
            this.wordSet = new WordSet(); // コンストラクト
        } finally {
            System.out.println("辞書ファイル(XML)入力完了");
        }

    }
    
    /*
     * メッセージ表示
     */
    private void message(String str){
        System.out.println(str);
        this.statusBar.setText(str);
    }

}